# 任务管理API 接口文档  

# 任务管理  

# 天风任务-创建任务  
url:http://192.168.189.101:8080/jeecg-boot

请求方式：POST  
请求路径：/task  

# 请求参数  

| 参数名            | 必填 | 描述                     |
|-------------------|------|--------------------------|
| vwedTaskId        | Y    | 天风任务 id              |
| vwedTaskParentId  | Y    | 天风任务父级任务 id, 没有就 "" |
| name              | Y    | 任务名称                 |
| isPeriodic        | Y    | 是否周期任务             |
| priority          | Y    | 优先级                   |
| createTime        | Y    | 任务创建时间             |

# 请求示例  

{
     "vwedTaskId": "2129e899-771a-46e2-a484-b655640ea801",
     "vwedTaskParentId": "",
     "name": "天风任务01",
     "isPeriodic": "1",
     "priority": "1",
     "createTime": "2025-04-08 22:03:57"
} 

# 返回值描述：  

| 参数名   | 类型   | 描述                   |
|----------|--------|------------------------|
| code     | int    | 返回状态码（200：成功，400：失败） |
| message  | string | 返回消息               |

# 返回示例  

成功  

{   
 "success": true,   
 "message": "success",   
 "code": 200,   
 "result": null,   
 "timestamp": 1741866819647   
}  

失败  

{   
 "success": false,   
 "message": "请设置任务优先级",   
 "code": 401,   
 "result": null,   
 "timestamp": 1741866819647   
}  

# 天风任务-选择amr  

请求方式：POST  

请求路径：/task/chooseAmr  

# 请求参数  

| 参数名             | 必填 | 描述                           |
|--------------------|------|--------------------------------|
| vwedTaskId         | Y    | 天风任务 id                    |
| keyStationName     | Y    | 关键站点名称                    |
| appointAmrName     | N    | 指定的 amr 名称，不指定留空 ""  |
| appointAmrGroupName| N    | 指定的 amr 分组名称，不指定留空 "" |

# 请求示例  

{   
 "vwedTaskId": "2129e899-771a-46e2-a484-b655640ea801",   
 "keyStationName": "TK01",   
 "appointAmrName": "",   
 "appointAmrGroupName": ""   
}  

# 返回示例  

成功  

{  
 "success": true,  
 "message": "",  
 "code": 200,  
 "result": {  
 "amrId": "1912349377797406722",//选定的 amrId  
 "amrName": "1921681102"//选定的 amr 名称  
 },  
}  

# 失败  

{
    "success": false,
    "message": "此任务已封口",
    "code": 400,
    "result": null,
    "timestamp": 1741866819647
}
# 天风任务-添加动作  

请求方式：POST  

请求路径：/task/addAction  

# 请求参数  

| 参数名       | 必填 | 描述         |
|--------------|------|--------------|
| vwedTaskId   | Y    | 天风任务 id  |
| stationName  | Y    | 站点名称     |
| action       | Y    | 动作         |

# 请求示例  

{
  "vwedTaskId": "2129e899-771a-46e2-a484-b655640ea801",
  "stationName": "PT02",
  "action": "JackUnLoad"
}

# 返回示例  

成功  

{   
 "success": true,   
 "message": "",   
 "code": 200,   
 "result": null,   
 "timestamp": 1745559946174   
}  

# 失败  

{   
 "success": false,   
 "message": "此任务动作已存在",   
 "code": 400,   
 "result": null,   
 "timestamp": 1741866819647   
}  

# 天风任务-封口  

请求方式：PUT  
请求路径：/task/{vwedTaskId}/closure  
请求参数: 无  
返回示例  

{   
 "success": true,   
 "message": "",   
 "code": 200,   
 "result": null,   
 "timestamp": 1745559946174   
}  

