# 流程功能块使用说明

## break (BreakBp)

### 描述
本块用于跳出当前循环。

### 输入参数
无

### 输出参数
无

## 延迟 (DelayBp)

### 描述
本块用于实现延迟执行。

### 输入参数

| 参数名      | 是否必填 | 类型   | 描述    |
|------------|---------|--------|---------|
| timeMillis | 必填     | Long   | 毫秒    |

### 输出参数
无

## If (IfBp)

### 描述
本块用于条件判断。

### 输入参数

| 参数名     | 是否必填 | 类型     | 描述   |
|-----------|---------|---------|--------|
| condition | 必填     | Boolean | 条件   |

### 子块

| 子块名  | 子块描述 |
|--------|---------|
| default | 默认    |

### 输出参数
无

## If-Else (IfElseBp)

### 描述
本块用于条件分支判断。

### 输入参数

| 参数名      | 是否必填 | 类型     | 描述    |
|------------|---------|---------|----------|
| conditionIf | 必填     | Boolean | if条件   |

### 子块

| 子块名 | 子块描述 |
|-------|---------|
| if    | if为真  |
| else  | else    |

### 输出参数
无

## 遍历数组 (IterateListBp)

### 描述
本块用于遍历数组中的元素。

### 输入参数

| 参数名 | 是否必填 | 类型      | 描述  |
|-------|---------|----------|-------|
| list  | 必填     | JSONArray | 数组  |

### 上下文变量

| 变量名 | 类型  | 描述     |
|-------|------|----------|
| index | Long | 循环索引  |
| item  | Any  | 当前项   |

### 子块

| 子块名   | 子块描述 |
|---------|---------|
| default | 默认    |

### 输出参数
无

## 并行执行 (ParallelFlowBp)

### 描述
本块用于并行执行多个子块。

### 输入参数
无

### 子块

| 子块名   | 子块描述 |
|---------|---------|
| default | 默认    |

### 输出参数
无

## 重复执行N次 (RepeatNumBp)

### 描述
本块用于重复执行子块N次。

### 输入参数

| 参数名 | 是否必填 | 类型  | 描述         |
|-------|---------|------|--------------|
| num   | 必填     | Long | 次数（N<1000）|

### 上下文变量

| 变量名 | 类型  | 描述     |
|-------|------|----------|
| index | Long | 循环索引  |

### 子块

| 子块名   | 子块描述 |
|---------|---------|
| default | 默认    |

### 输出参数
无

## return (ReturnBp)

### 描述
本块用于从当前流程返回。

### 输入参数
无

### 输出参数
无

## 串行执行 (SerialFlowBp)

### 描述
本块用于串行执行多个子块。

### 输入参数
无

### 子块

| 子块名   | 子块描述 |
|---------|---------|
| default | 默认    |

### 输出参数
无

## 抛出异常 (ThrowExceptionBp)

### 描述
本块用于抛出异常。

### 输入参数

| 参数名   | 是否必填 | 类型   | 描述       |
|---------|---------|--------|------------|
| message | 必填     | String | 异常提示文本 |

### 输出参数
无

## while (WhileBp)

### 描述
本块用于循环执行。

### 输入参数

| 参数名            | 是否必填 | 类型     | 描述                    |
|------------------|---------|---------|-------------------------|
| loopCondition    | 必填     | Boolean | 循环条件                 |
| runOnce          | 非必填   | Boolean | 至少执行一次子块          |
| retryPeriod      | 非必填   | Long    | 循环时间间隔(ms)          |
| printContinuously | 非必填   | Boolean | 是否持续打印日志(默认为false) |

### 子块

| 子块名   | 子块描述 |
|---------|---------|
| default | 默认    |

### 输出参数
无 