# 机器人调度功能块使用说明

## 机器人通用动作 (CAgvOperationBp)

### 描述
本块用于执行机器人通用动作。

### 输入参数

| 参数名          | 是否必填 | 类型      | 描述       |
|----------------|---------|----------|------------|
| targetSiteLabel | 必填    | String   | 目标站点名  |
| spin           | 非必填   | Boolean  | 允许随动    |
| task           | 非必填   | JSONArray | 指令       |

### 指令选项

机器人指令支持多种类型，包括：
- binTask：binTask
- preBinTask：预置binTask
- JackLoad：顶升 JackLoad
- JackHeight：设置顶升高度 JackHeight
- JackUnload：顶降 JackUnload
- Wait：等待 Wait
- ForkLoad：叉车取货 ForkLoad
- ForkUnload：降低叉齿 ForkUnload
- ForkHeight：边走边升降叉齿 ForkHeight
- CustomCommand：自定义指令
- syspy/setDO.py：syspy/setDO.py
- syspy/waitDO.py：syspy/waitDO.py

### 上下文变量

| 变量名       | 类型   | 描述   |
|-------------|--------|--------|
| containerName | String | 料箱名 |

### 输出参数
无

## 选择执行机器人 (CSelectAgvBp)

### 描述
本块用于选择执行任务的机器人。

### 输入参数

| 参数名     | 是否必填 | 类型   | 描述                |
|-----------|---------|--------|---------------------|
| priority  | 非必填   | Long   | 优先级（越大优先级越高）|
| vehicle   | 非必填   | String | 指定机器人           |
| group     | 非必填   | String | 指定机器人组         |
| keyRoute  | 必填     | String | 关键路径             |

### 上下文变量

| 变量名        | 类型   | 描述       |
|--------------|--------|------------|
| selectedAgvId | String | 选出的机器人 |

### 子块

| 子块名   | 子块描述 |
|---------|---------|
| default | 默认    |

### 输出参数
无

## 获取机器人位置 (VehicleStationBp)

### 描述
本块用于获取机器人当前位置。

### 输入参数

| 参数名   | 是否必填 | 类型   | 描述      |
|---------|---------|--------|-----------|
| vehicle | 必填     | String | 指定机器人 |

### 上下文变量

| 变量名      | 类型   | 描述     |
|------------|--------|----------|
| station    | String | 当前位置  |
| lastStation | String | 上次位置  |

### 输出参数
无

## 获取机器人电量 (GetBatteryLevelBp)

### 描述
本块用于获取机器人当前电量。

### 输入参数

| 参数名   | 是否必填 | 类型   | 描述      |
|---------|---------|--------|-----------|
| vehicle | 必填     | String | 机器人ID  |

### 上下文变量

| 变量名       | 类型   | 描述  |
|-------------|--------|-------|
| batteryLevel | Double | 电量  |

### 输出参数
无

## 获取机器人 PGV 码 (GetPGVCodeBp)

### 描述
本块用于获取机器人 PGV 码信息。

### 输入参数

| 参数名   | 是否必填 | 类型   | 描述      |
|---------|---------|--------|-----------|
| vehicle | 必填     | String | 机器人ID  |

### 上下文变量

| 变量名    | 类型    | 描述       |
|----------|---------|------------|
| codeInfo | Boolean | 二维码信息  |

### 输出参数
无 